/* RTC֘A */

#include "bootpack.h"

/* CMOSf[^擾 */
int readdate_cmos(unsigned char *a)
{
	char ef;
	static unsigned char adr[7] = { 0x00, 0x02, 0x04, 0x07, 0x08, 0x09, 0x32 };
	static unsigned char max[7] = { 0x60, 0x59, 0x23, 0x31, 0x12, 0x99, 0x99 };
	int i;	
	
	/*  ** ڍ׏ **
		0x00 b
		0x02 
		0x04 
		0x07 
		0x08 
		0x09 N̉Q
		0x32 N̏Q
	*/

	/* xǂ݂܂ł̃[v */
	for (;;) {
		ef = 0;
		for (i = 0;i < 7;i++) {
			io_out8(0x70, adr[i]);
			a[i] = io_in8(0x71);
		}
		for (i = 0;i < 7;i++) {
			io_out8(0x70, adr[i]);
			if (a[i] != io_in8(0x71) || (a[i] & 0x0f) > 9 || a[i] > max[i]) {
				ef = 1;
			}
		}
		if (ef == 0) {
			return 0;
		}
	}
}

struct TASK *clktask;

/* vN */
void run_clock(void)
{
	clktask = task_alloc();
	clktask->tss.esp = memman_alloc_4k(64 * 1024) + 64 * 1024;
	clktask->tss.eip = (int) &clock_task;
	clktask->tss.es = 1 * 8;
	clktask->tss.cs = 2 * 8;
	clktask->tss.ss = 1 * 8;
	clktask->tss.ds = 1 * 8;
	clktask->tss.fs = 1 * 8;
	clktask->tss.gs = 1 * 8;
	task_run(clktask, 2, 2, "clock");

	return;
}

/* vI */
void stop_clock(void)
{
	task_sleep(clktask);
	memman_free_4k(clktask->tss.esp, 64 * 1024);
	clktask->flags = 0;
	return;
}

/* v̖{ */
void clock_task(void)
{
	unsigned char date[7];
	char s[64];
	
	for (;;) {
		/* ꕪɍXV */
		readdate_cmos(date);
		sprintf(s, "%02x:%02x", date[2], date[1]);
		boxfill8(sht_back->buf, sht_back->bxsize, COL8_FFFFFF, 
				sht_back->bxsize - 60, 2, sht_back->bxsize - 3, 21);
		putfonts8_asc(sht_back->buf, sht_back->bxsize, 
				sht_back->bxsize - 53, 4, COL8_000000, s);
		sheet_refresh(sht_back, sht_back->bxsize - 60, 2, sht_back->bxsize - 3, 21);
		kernel_sleep(6000);
	}
}

